#include <sys\stat.h>
#include <process.h>
#include <io.h>
#include <dir.h>
#include <stdio.h>
#include <iostream.h>
#include <string.h>

/*


	Set tabstops to 2 amd the listing should look OK.

	This may not be the most elegant way of performing functions but it WORKS !
	It was compiled under BC4. NO warnings or errors
	
	The functiom will erase the files according to the filespec specified.
	Its like the DOS DEL command but this wont ask for 'are you sure' which
	is annoying when using del *.* in a batch file

	It will change directory using chnmod and revert back to the current directory
	when its completed.

	Its a good example of using findfirst and findnext.

	Perhaps useful for beginners who are learning, however Im self taught so it
	may not be a very good example !

	I normally  program in assembler or in C++ under Windows. DOS doesnt get used
	that much these days !

	This code is supplied free for anybody to use modify redistribute etc etc.
	NO Royalties wanted, Oh yeah, And NO Warranties and you cant hold me responsible
	for anything, implied or otherwise !


	Any remarks, comments, constructive critisisms advice etc etc gratefully received to :
		Andy Richards	100102,3104


*/

int main(int argc, char * argv[] )	 					// Can return -1 so batch files can use result on error
{
	struct ffblk fblk;                          // used with findfirst, findnext
	int dosfind;

	char sname[MAXFILE+MAXEXT+1];               // used for splitting up filenames and paths
	char path[MAXPATH];
	char drive[MAXDRIVE];
	char dir[MAXDIR];
	char fname[MAXFILE];
	char fext[MAXEXT];

	char current_path[MAXPATH];                 // for current working directory

	int verbose;																// flag for verbose output

	// Output some help if switch /? is specified

	if (argc == 1 || strcmp(argv[1], "/?") == 0)	{
		cout << "\r\nXERA <filespec> /v for Verbose \r\n"
						"Deletes files. e.g. XERA ..\\123\\abc\\*.dl_\r\n"
						"(No questions asked.. BEWARE!) AWR 94\r\n";

		exit(2);																	// different DOS error level just for kicks
		}

	char *ptr = strupr(argv[2]);
	verbose = (strcmp(ptr, "/V") == 0);

	fnsplit(argv[1],drive,dir,fname,fext);      // get filespec into appropiate locations
	fnmerge(path,drive,dir,NULL,NULL);          // make a path so we can change to the directory
	fnmerge(sname,NULL,NULL,fname,fext);				// now get the wildcards or filename and extension

	getcwd(current_path,MAXPATH);               // retrieve the current directory so we can switch back
	path[strlen(path)-1] = 0;                   // now remove the trailing backslash so chmod will accept

	if (chdir(path) == -1)	{                   // attempt to switch to the directory asked for
		cout  << path                             // abort if not possible
					<< " Directory not found\r\n";
		exit(1);																	// bomb out setting DOS error level to -1
		}

	dosfind = findfirst(sname,&fblk,0);         // Now find the first file using findfirst and ALL files

	while (!dosfind)	{                         // are there any files ? (note its NOT dosfind)

		// Ensure we can remove readonly files also
		// and inform but not abort if permission denied
		if (chmod(fblk.ff_name, S_IREAD | S_IWRITE) != 0)
			cout	<< "XERA CANNOT remove "	<< fblk.ff_name	<< "\r\n";

		// if outputting loads of messages ( /V switch )
		// then inform or removal of file
		if (verbose)
			cout	<< "XERA is removing "	<< fblk.ff_name	<< "\r\n";

		// delete the file - weve already checked for readwrite using
		// chmod just above
		//unlink( fblk.ff_name);

		// now get the next file to remove in the directory
		dosfind = findnext(&fblk);

		}	// end while loop

	// Now move back to the directory that we were in before we selected
	// the specified directory. Report if not able to do so

	if (chdir(current_path) == -1)	{
		cout <<	"Unable to revert to working directory \r\n";
		exit(1);
		}

	return 0;                                    // exit no errors found ALL OK !
}




















